// SHBrowseForFolderDlg.cpp : implementation file
//

#include "stdafx.h"
#include "SHBrowseForFolder.h"
#include "SHBrowseForFolderDlg.h"

#include "Shell.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSHBrowseForFolderDlg dialog

CSHBrowseForFolderDlg::CSHBrowseForFolderDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSHBrowseForFolderDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSHBrowseForFolderDlg)
	m_bComputer = FALSE;
	m_sDisplayName = _T("");
	m_bEditBox = FALSE;
	m_sFolder = _T("");
	m_bIncludeFiles = FALSE;
	m_bNoBelow = FALSE;
	m_bOnlyDirs = FALSE;
	m_sPathName = _T("");
	m_bStatus = FALSE;
	m_sTitle = _T(" :");
	m_bUsePidl = FALSE;
	m_nIndex = 0;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSHBrowseForFolderDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSHBrowseForFolderDlg)
	DDX_Control(pDX, IDC_SPECIAL, m_Special);
	DDX_Control(pDX, IDC_FILEICON, m_Icon);
	DDX_Check(pDX, IDC_COMPUTER, m_bComputer);
	DDX_Text(pDX, IDC_DISPLAYNAME, m_sDisplayName);
	DDX_Check(pDX, IDC_EDITBOX, m_bEditBox);
	DDX_Text(pDX, IDC_FOLDER, m_sFolder);
	DDX_Check(pDX, IDC_INCLUDEFILES, m_bIncludeFiles);
	DDX_Check(pDX, IDC_NOBELOW, m_bNoBelow);
	DDX_Check(pDX, IDC_ONLYDIRS, m_bOnlyDirs);
	DDX_Text(pDX, IDC_PATHNAME, m_sPathName);
	DDX_Check(pDX, IDC_STATUS, m_bStatus);
	DDX_Text(pDX, IDC_TITLE, m_sTitle);
	DDX_Check(pDX, IDC_USEPIDL, m_bUsePidl);
	DDX_CBIndex(pDX, IDC_SPECIAL, m_nIndex);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSHBrowseForFolderDlg, CDialog)
	//{{AFX_MSG_MAP(CSHBrowseForFolderDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BROWSE, OnBrowse)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSHBrowseForFolderDlg message handlers

BOOL CSHBrowseForFolderDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	int nIndex = m_Special.AddString("Control Panel");
	m_Special.SetItemData(nIndex, CSIDL_CONTROLS);
	nIndex = m_Special.AddString("Favorites");
	m_Special.SetItemData(nIndex, CSIDL_FAVORITES);
	nIndex = m_Special.AddString("Printers");
	m_Special.SetItemData(nIndex, CSIDL_PRINTERS);
	nIndex = m_Special.AddString("Fonts");
	m_Special.SetItemData(nIndex, CSIDL_FONTS);
	nIndex = m_Special.AddString("SendTo");
	m_Special.SetItemData(nIndex, CSIDL_SENDTO);
	m_Special.SetCurSel(0);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CSHBrowseForFolderDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CSHBrowseForFolderDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CSHBrowseForFolderDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

static int CALLBACK BrowseCallbackProc(HWND hWnd, UINT Msg, LPARAM lParam, LPARAM dwData)
{
	switch (Msg)
	{
	case BFFM_INITIALIZED:
		{
			//ĸǿ Help 
			DWORD dwStyle = GetWindowLong(hWnd, GWL_EXSTYLE);
			SetWindowLong(hWnd, GWL_EXSTYLE, dwStyle & ~WS_EX_CONTEXTHELP);

			//Status text 3D ׵θ ÷
			HWND hwndLabel = GetDlgItem(hWnd, 0x3743);
			if (IsWindow(hwndLabel))
			{
				TCHAR szClass[MAX_PATH] = {0};
				GetClassName(hwndLabel, szClass, MAX_PATH);
				if (lstrcmpi(szClass, __TEXT("static")))
					break;
			}
			else
				break;
			dwStyle = GetWindowLong(hwndLabel, GWL_EXSTYLE);
			SetWindowLong(hwndLabel, GWL_EXSTYLE, dwStyle | WS_EX_STATICEDGE);
			SetWindowPos(hwndLabel, NULL, 0, 0, 0, 0,
				SWP_NOSIZE | SWP_NOMOVE | SWP_DRAWFRAME);
		}
		::SendMessage(hWnd, BFFM_SETSELECTION, TRUE, dwData);
		break;
	case BFFM_SELCHANGED:
		{
			TCHAR szText[MAX_PATH] = {0};
			SHGetPathFromIDList(reinterpret_cast<LPITEMIDLIST>(lParam), szText);
			SendMessage(hWnd, BFFM_SETSTATUSTEXT, 0, reinterpret_cast<LPARAM>(szText));
		}
		break;
	}
		
	return 0;
}

void CSHBrowseForFolderDlg::OnBrowse() 
{
	if (!UpdateData()) return;

	int nFolder = 0;
	if (m_bUsePidl)
		nFolder = m_Special.GetItemData(m_nIndex);
	UINT uiFlags = 0;
	if (m_bNoBelow) uiFlags |= BIF_DONTGOBELOWDOMAIN;
	if (m_bOnlyDirs) uiFlags |= BIF_RETURNONLYFSDIRS;
	if (m_bIncludeFiles) uiFlags |= BIF_BROWSEINCLUDEFILES;
	if (m_bEditBox) uiFlags |= BIF_EDITBOX | BIF_VALIDATE;
	if (m_bStatus) uiFlags |= BIF_STATUSTEXT;
	if (m_bComputer) uiFlags |= BIF_BROWSEFORCOMPUTER;

	LPITEMIDLIST pidl = NULL;
	if (!m_sFolder.IsEmpty())
	{	//־ θ PIDL ȯѴ.
		CShell::PathToPidl(m_sFolder, &pidl);
	}

	if (CShell::BrowseForFolder(m_sPathName, m_sTitle, m_hWnd, uiFlags, nFolder, pidl) != IDOK) return;
	
	LPMALLOC pMalloc = NULL;
	SHGetMalloc(&pMalloc);
	pMalloc->Free(pidl);
	pMalloc->Release();

	UpdateData(false);
}
